// Generated by CoffeeScript 1.12.7
var feedback, scoring;

scoring = require('./scoring');

feedback = {
  default_feedback: {
    warning: '',
    suggestions: ["Geben Sie ein paar Begriffe ein, auch Ziffern und Sonderzeichen. Beispiel: „123GrünePferdeEssenÄpfelSehrSehrGerne!“ Hinweis: Sie können Ihr Passwort in Ihrem Wallet speichern und später zurücksetzen.", "Man muss nicht unbedingt Symbole, Nummern und große Buchstaben nutzen"]
  },
  get_feedback: function(score, sequence) {
    var extra_feedback, i, len, longest_match, match, ref;
    if (sequence.length === 0) {
      return this.default_feedback;
    }
    if (score > 2) {
      return {
        warning: '',
        suggestions: []
      };
    }
    longest_match = sequence[0];
    ref = sequence.slice(1);
    for (i = 0, len = ref.length; i < len; i++) {
      match = ref[i];
      if (match.token.length > longest_match.token.length) {
        longest_match = match;
      }
    }
    feedback = this.get_match_feedback(longest_match, sequence.length === 1);
    extra_feedback = 'Geben Sie noch weitere Begriffe ein. Seltene Wörter sind besser.';
    if (feedback != null) {
      feedback.suggestions.unshift(extra_feedback);
      if (feedback.warning == null) {
        feedback.warning = '';
      }
    } else {
      feedback = {
        warning: '',
        suggestions: [extra_feedback]
      };
    }
    return feedback;
  },
  get_match_feedback: function(match, is_sole_match) {
    var layout, warning;
    switch (match.pattern) {
      case 'dictionary':
        return this.get_dictionary_match_feedback(match, is_sole_match);
      case 'spatial':
        layout = match.graph.toUpperCase();
        warning = match.turns === 1 ? 'Verwenden Sie nicht mehrere nebeneinanderliegende Tasten auf Ihrer Tastatur. Beispiel: „qwert“.' : 'Verwenden Sie keine Kombination aus benachbarten Tasten auf Ihrer Tastatur, wie z.B. „zuhjnm“.';
        return {
          warning: warning,
          suggestions: ['Wählen Sie stattdessen lieber einen langen Satz aus.']
        };
      case 'repeat':
        warning = match.base_token.length === 1 ? 'Wiederholen Sie keine Buchstabenfolgen, wie z.B. „abcabcabc“.' : 'Wiederholungen wie "abcabcabc" sind unwessentlich besser als nur "abc"';
        return {
          warning: warning,
          suggestions: ['Wählen Sie stattdessen lieber einen langen Satz aus.']
        };
      case 'sequence':
        return {
          warning: "Geben Sie keine Ziffernfolgen, wie „4567“, beim Erstellen Ihres Passworts ein.",
          suggestions: ['Wählen Sie stattdessen lieber einen langen Satz aus.']
        };
      case 'regex':
        if (match.regex_name === 'recent_year') {
          return {
            warning: "Letze Jahre sind leicht zu erraten",
            suggestions: ['Verwenden Sie keine Jahreszahlen, wie z.B. „1989“.', 'Vermeiden Sie Jahre die mit Ihnen verbunden seien können', 'Wählen Sie stattdessen lieber einen langen Satz aus.']
          };
        }
        break;
      case 'date':
        return {
          warning: "Sie sollten auch keine Datumsangaben verwenden, wie z.B. einen Geburtstag.",
          suggestions: ['Verwenden Sie keine Datumsangaben, wie z.B. einen Geburtstag.', 'Wählen Sie stattdessen lieber einen langen Satz aus.']
        };
    }
  },
  get_dictionary_match_feedback: function(match, is_sole_match) {
    var ref, ref1, result, suggestions, warning, word;
    warning = match.dictionary_name === 'passwords' ? is_sole_match && !match.l33t && !match.reversed ? match.rank <= 10 ? 'Vorsicht! Das ist ein weitverbreitetes und daher sehr unsicheres Passwort.' : match.rank <= 100 ? 'Vorsicht! Das ist ein weitverbreitetes und daher sehr unsicheres Passwort.' : 'Vorsicht! Das ist ein weitverbreitetes und daher sehr unsicheres Passwort.' : match.guesses_log10 <= 4 ? 'Vorsicht! Das ist sehr ähnlich zu einem sehr häufigen Passwort.' : void 0 : (ref = match.dictionary_name) === 'english_wikipedia' || ref === 'populaere' ? is_sole_match ? 'Einfach nur ein Wort, wie „Zucker“ als Passwort einzugeben, ist sehr unsicher.' : void 0 : (ref1 = match.dictionary_name) === 'surnames' || ref1 === 'male_names' || ref1 === 'female_names' || ref1 === 'vornamen' || ref1 === 'nachnamen' ? is_sole_match ? 'Einen Vor- und Nachnamen als Passwort zu hinterlegen, ist keine gute Wahl.' : 'Einen Vor- und Nachnamen als Passwort zu hinterlegen, ist ebenfalls keine gute Wahl.' : '';
    suggestions = [];
    word = match.token;
    if (word.match(scoring.START_UPPER)) {
      suggestions.push("Ein Wort in Großbuchstaben erhöht nicht unbedingt die Sicherheit Ihres Passworts.");
    } else if (word.match(scoring.ALL_UPPER) && word.toLowerCase() !== word) {
      suggestions.push("Den ersten Buchstaben einen Wortes großzuschreiben, trägt auch nicht unbedingt zur Sicherheit Ihres Passworts bei.");
    }
    if (match.reversed && match.token.length >= 4) {
      suggestions.push("Ein rückwärts geschriebenes Wort als Passwort zu verwenden, ist auch nicht sicher.");
    }
    if (match.l33t) {
      suggestions.push("Einzelne Buchstaben eines Wortes durch Sonderzeichen zu ersetzen, z.B. „B@nk“, macht Ihr Passwort nicht sicherer.");
    }
    result = {
      warning: warning,
      suggestions: suggestions
    };
    return result;
  }
};

module.exports = feedback;

//# sourceMappingURL=feedback.js.map
